<template>
  <v-main class="app">
    <piece-loader
      :client="client"
      :piece-path="piecePath"
      @update:piece="onPieceLoad"
    />
    <!-- The main dezrann component -->
    <!-- Receives a piece and sync, and handles display and editing -->
    <sync-editor
      v-if="piece && unit"
      :clean.sync="clean"
      :piece="piece"
      :track="track"
      :unit="unit"
    />
    <!-- Renders sync control buttons on the sidebar -->
    <portal v-slot="{ isMinified }" to="sidebar-buttons">
      <sync-sidebar-items
        v-if="piece"
        :client="client"
        :piece="piece"
        :clean.sync="clean"
        :unit="unit"
        :track="track"
        :is-minified="isMinified"
        @replace-unit="replaceSyncTable"
        @reset-unit="resetSync"
      />
    </portal>
    <title-manager
      v-if="piece"
      :title="piece.getTitle($i18n.locale)"
      :subtitle="piece.getMetadataOne($i18n.locale)"
      :metadata="piece.getMetadataTwo($i18n.locale)"
    />
  </v-main>
</template>

<script lang="ts">
import { Component, Watch } from 'vue-property-decorator';
import type { Route } from 'vue-router';
import TitleManager from '@/components/navigation/TitleManager.vue';
import SyncSidebarItems from '@/components/navigation/synchronization/SyncSidebarItems.vue';
import SyncEditor from '@/components/SynchronizationEditor.vue';
import PieceLoader from '@/vuejs/components/loaders/PieceLoader.vue';
import type {
  Piece, Audio, UnitTable,
} from '@/data';
import { EditableUnit } from '@/data';

import {
  warnSyncUnsaved,
  warnSyncMissing,
} from '@/components/dialogs';

import type { Client } from '@/client';
import { extractQueryInt, getClient, getPiecePath } from '@/vuejs/components/utils/nav-tools';
import CleanCheckPage from './CleanCheckPage.vue';

/**
 * The main dezrann integration
 * loads piece and sync for the SyncEditor
 * then displays a piece sync and lets a user modify it
 */
@Component({
  components: {
    SyncEditor,
    SyncSidebarItems,
    PieceLoader,
    TitleManager,
  },
})
export default class SyncPage extends CleanCheckPage {
  // the data passed to the editor once loaded

  track: Audio | null = null;

  unit: EditableUnit | null = null;

  piece: Piece | null = null;

  /** The current piece path, to load the piece from the client */
  get piecePath(): string { return getPiecePath(this.$route); }

  /** The current client for this route */
  get client(): Client { return getClient(this.$route); }

  /** Get the id from the query */
  get syncId(): number | null { return extractQueryInt(this.$route.query.sync); }

  /** Init the sync query to 0 */
  initSyncIdQuery() {
    this.$router.replace({
      query: { ...this.$route.query, sync: '0' },
    });
  }

  async onPieceLoad(piece: Piece) {
    this.piece = piece;
    this.onSyncIdChange();
  }

  @Watch('$route.query.sync')
  async onSyncIdChange() {
    // If no piece is loaded, ignore change. sync will be loaded by onPieceLoad
    if (!this.piece) return;

    if (this.syncId === null) {
      // Update query, causing this function to be called again by watch
      this.initSyncIdQuery();
    } else {
      this.loadSync();
    }
  }

  async resetSync() {
    if (this.track) {
      const trackUnit = this.track.secondUnit.tables[0];
      const firstSyncPoint = trackUnit[0];
      const lastSyncPoint = trackUnit[trackUnit.length - 1];
      this.replaceSyncTable([firstSyncPoint, lastSyncPoint]);
    }
  }

  /**
   * Called by JSON load and table reset
   * a bit hacky, would be solved by using unit table injection instead of editing the actual piece
   */
  async replaceSyncTable(table: UnitTable) {
    if (!this.piece || !this.unit) throw new Error('Cannot load sync before piece is loaded');

    // check data loss
    if (!this.clean && !await this.warnUser()) return;

    // reset the previous unit
    this.unit.resetTable();
    // apply loaded table
    this.unit.setTable(table);
    // set clean
    this.clean = true;
  }

  /**
   * load/reload the unit object
   */
  loadSync() {
    if (!this.piece || this.syncId === null) throw new Error('Cannot load sync before piece is loaded');

    if (!this.piece?.tracks?.[this.syncId]) {
      warnSyncMissing();
      return;
    }

    // Remove any change to the previously selected unit
    // TODO: instead of modifying the actual source, use some kind of unit injector
    if (this.unit) this.unit.resetTable();

    this.track = this.piece.tracks[this.syncId];
    this.unit = new EditableUnit(this.track.secondUnit, 0);
    this.clean = true;
  }

  /**
   * @override
   * Warns the user in case of unsaved sync on routing
   */
  warnUser = warnSyncUnsaved;

  /**
   * @override
   * Check if new route will erase current sync
   * Use by CleanCheckPage
   */
  checkRouteChange(to: Route, from: Route): boolean {
    return to.query.sync !== from.query.sync;
  }
}
</script>
